    /**********************************************
*
* PIC24FJ128GB106 family 
* 2024.12.10
* 320x240 TFT LCD display program with SD card driver
*
  |[^uQ[@p̈TFT LCDGIF̉摜\鎖
  ړIɊJr̃vO
     * 
***********************************************/
// PIC24FJ128GB106 Configuration Bit Settings

// 'C' source line config statements
/*
// CONFIG3
#pragma config WPFP = WPFP511           // Write Protection Flash Page Segment Boundary (Highest Page (same as page 85))
#pragma config WPDIS = WPDIS            // Segment Write Protection Disable bit (Segmented code protection disabled)
#pragma config WPCFG = WPCFGDIS         // Configuration Word Code Page Protection Select bit (Last page(at the top of program memory) and Flash configuration words are not protected)
#pragma config WPEND = WPENDMEM         // Segment Write Protection End Page Select bit (Write Protect from WPFP to the last page of memory)

// CONFIG2
#pragma config POSCMOD = NONE           // Primary Oscillator Select (Primary oscillator disabled)
#pragma config DISUVREG = OFF           // Internal USB 3.3V Regulator Disable bit (Regulator is disabled)
#pragma config IOL1WAY = OFF            // IOLOCK One-Way Set Enable bit (Unlimited Writes To RP Registers)
#pragma config OSCIOFNC = OFF           // Primary Oscillator Output Function (OSCO functions as CLKO (FOSC/2))
#pragma config FCKSM = CSDCMD           // Clock Switching and Monitor (Both Clock Switching and Fail-safe Clock Monitor are disabled)
#pragma config FNOSC = FRCPLL           // Oscillator Select (Fast RC oscillator with Postscaler and PLL module (FRCPLL))
#pragma config PLL_96MHZ = ON           // 96MHz PLL Disable (Enabled)
#pragma config PLLDIV = DIV2            // USB 96 MHz PLL Prescaler Select bits (Oscillator input divided by 2 (8MHz input))
#pragma config IESO = OFF               // Internal External Switch Over Mode (IESO mode (Two-speed start-up)disabled)

// CONFIG1
#pragma config WDTPS = PS32768          // Watchdog Timer Postscaler (1:32,768)
#pragma config FWPSA = PR128            // WDT Prescaler (Prescaler ratio of 1:128)
#pragma config WINDIS = OFF             // Watchdog Timer Window (Standard Watchdog Timer enabled,(Windowed-mode is disabled))
#pragma config FWDTEN = OFF             // Watchdog Timer Enable (Watchdog Timer is disabled)
#pragma config ICS = PGx1               // Comm Channel Select (Emulator functions are shared with PGEC1/PGED1)
#pragma config GWRP = OFF               // General Code Segment Write Protect (Writes to program memory are allowed)
#pragma config GCP = OFF                // General Code Segment Code Protect (Code protection is disabled)
//#pragma config JTAGEN = OFF             // JTAG Port Enable (JTAG port is disabled)
*/
// #pragma config statements should precede project file includes.
// Use project enums instead of #define for ON and OFF.

#include <xc.h>
#include <string.h>

#define FCY 16000000UL// libpic30.h̑OFosc/2`@__delay֐p
#include <libpic30.h> 
#include "Font7.h"
#include "SDC_main.h"
#include "BMP_display_system.h"

 



#define LCD_CS LATEbits.LATE6
#define LCD_DC LATEbits.LATE7
#define LCD_RES LATGbits.LATG6
#define GLED LATBbits.LATB8
#define TEST LATDbits.LATD2
#define SD_CD PORTDbits.RD1
#define KDIR PORTBbits.RB12
#define KUP PORTBbits.RB13
#define KDOWN PORTBbits.RB14
#define KENTER PORTBbits.RB15
#define us unsigned

us char lastKDIR,lastKUP,lastKDOWN,lastKENTER;
us char mojicolor,backcolor;
us char No_media,SD_CK,lastSD_CD,CHATA;
unsigned int FX,FY;//tHg\̊JnW
unsigned int GX,GY,GIFx,GIFy;//Ot\W@sNZTCY@x,y
unsigned int F_col,F_row;
us char lcd_digi[10];
us char coment[]="happy new year";
us int year;
uint8_t str[32];
//unsigned long int DISPFREQ,lastDISPFREQ,BASEFREQ;
us char color[17][3];//18bit color data
uint8_t readFname[11][32];
unsigned char maxFname,FnameIndex;
int openid,Hgif,Vgif,offset;//
us int xt,yt,st;
//uint8_t fname8[32];
//֐錾
void disp_dir_fname();
void File_open(FnameIndex);

unsigned char color0[16][3]= {//24bit color data RGB
	{0,0,0},//0 
	{255,0,0},//1@
	{0,255,0},//2@
	{0,100,255},//3@
	{255,255,0},//4@
	{0,255,255},//5@VA
	{255,0,255},//6@
	{255,255,255},//7@
	{0,0,120},//8@
	{120,0,0},//9@
	{0,50,0},//10@
	{120,120,0},//11@
	{0,30,50},//12
	{120,0,120},//13
	{60,60,60},//14
	{255,70,0}//15
  
};

void lcd_CMD(unsigned char CM) {

    LCD_DC = 0;    
	LCD_CS = 0;
	
	SPI2BUF = CM;
    __delay_us(2) ;
	LCD_CS = 1;
}
void lcd_DATA(unsigned char DA) {

    LCD_DC = 1;
	LCD_CS = 0;
	
	SPI2BUF = DA;
    __delay_us(2) ;
	LCD_CS = 1;

}
void init_LCD() {
	LCD_RES = 0;
	__delay_ms(120) ;

	LCD_RES = 1;
	__delay_ms(120) ;

    lcd_CMD(0x01);
   
	__delay_ms(120) ;
    
	lcd_CMD(0x11);//Sleep Out
    lcd_CMD(0x28);// display off
	__delay_ms(120) ;
	lcd_CMD(0x36);
     
	lcd_DATA(0b01100100);
    lcd_CMD(0x3A);
	lcd_DATA(0x66);

	lcd_CMD(0x2A);
	lcd_DATA(0x00);
	lcd_DATA(0x00);
	lcd_DATA(0x01);//    01
	lcd_DATA(0x3F);//319 3F
	lcd_CMD(0x2B);
	lcd_DATA(0x00);
	lcd_DATA(0x00);
	lcd_DATA(0x00);//     00
	lcd_DATA(0xEF);//239  EF

	__delay_ms(200) ;
	
}



void itostring(unsigned char digit, unsigned long int data,unsigned  char *buffer) {
	unsigned char i;
	buffer += digit;
	*buffer =0;					// Ō̐ʒu
	for(i=digit; i>0; i--) {			// ϊ͉ʂʂ
            buffer--;					// |C^[P
            *buffer = (data % 10) + '0';	// ASCII
            data = data / 10;				// ̌
	}
}
void set_col_range(unsigned int start, unsigned int end) {//s͈͂̎w
	lcd_CMD(0x002A);
	lcd_DATA(start >> 8);
	lcd_DATA(start);
	lcd_DATA(end >> 8);
	lcd_DATA(end);
	}
void set_row_range(unsigned int start, unsigned int end) {//͈͂̎w
	lcd_CMD(0x002B);
	lcd_DATA(start >> 8);
	lcd_DATA(start);
	lcd_DATA(end >> 8);
	lcd_DATA(end);
	}

void set_LCDcolor(unsigned char C) {//24bitRGB?16bitRGB
	unsigned int c0;
    us int cr,cg,cb;
    c0 = 0;
	cr =255- color0[C][0];//
	cg =255- color0[C][1];// 
	cb =255- color0[C][2];//

	color[C][0] = cr;
	color[C][1] = cg;
    color[C][2] = cb;
}

void makecolorList(){
	us char i;
	for (i = 0;i <= 15;i++){
		set_LCDcolor(i);
	}
}
void write_color(unsigned char C) {
	lcd_DATA(color[C][0]);
	lcd_DATA(color[C][1]);
    lcd_DATA(color[C][2]);
}
void select_font_mk2(unsigned int F) {
    switch (F) {
        case  7:F_col=6;F_row=9;break;//ۂ̃tHghbg-1l
        case  6:F_col=5;F_row=9;break;
        case 12:F_col=11;F_row=21;break;
    }
}
void mojidisp_mk2(us char f,us char ch,us char spn) {//BLOCK\
	int k;
    const unsigned char *fc;
	int x,y,ma,mj;

	set_col_range(FX,FX+F_col);
 	set_row_range(FY,FY+F_row);
 	lcd_CMD(0x2C);//Ff[^

    switch (f) {
        case 7:fc = Font7_table[ch];break;
//		case 6:fc = Font6_table[ch];break;
//        case 12:fc = Font12_table[ch];break;
     }

	mj = F_col;

 	for (y=0;y<=F_row;y++) {
 		mj = F_col;
 		for (x=0;x<=F_col;x++) {
 			ma = mj % 8;//ma:mj8ŊZ]
 			k=(*fc) & (1<< ma);
 				if (k>0) {
                    write_color(mojicolor);//F
 				} else {
 					write_color(backcolor);//wiF
					
 				}
                mj--;
                if (ma == 0) {if (x < F_col) {fc++;}}
 			}
                
 		fc++;
 	}
	FX=FX+F_col+spn;
}


void mojiretsudisp_mk2( us int x,us int y,us char fnt,  char *str,us char spn) {//  \
    unsigned char i;
    char len;
	FX = x; FY =y;
	select_font_mk2(fnt);
	len = strlen(str);
	for (i=0;i<len;i++) {
        mojidisp_mk2(fnt,str[i],spn);
	}
}


void write_dots(int x,int y,int d,char c) {//x:W@y:yW@d:@c:Fԍ
	int i,j;
	set_col_range(x,x+d);
 	set_row_range(y,y+d);
	lcd_CMD(0x2C);//Ff[^
	for (i=x;i<x+d;i++) {
 		for (j=y;j<=y+d;j++) {
 			write_color(c);//F
 		}
	}
}


void integerdisp(us int x, us int y,us char fnt,us char degi, us long int num,us char spn) {
    FX=x;FY=y;
    itostring(degi,num,lcd_digi);//ASCIIɕϊ
    mojiretsudisp_mk2(x,y,fnt,lcd_digi,spn);
}


void write_line(unsigned int xs,unsigned int ys,unsigned int xe,unsigned int ye,unsigned char c) {
    unsigned int i,j;
    set_col_range(xs,xe);
    set_row_range(ys,ye);
    lcd_CMD(0x2C);//Ff[^
    for (i=ys;i<=ye;i++) {
        for (j=xs;j<=xe;j++) {
            write_color(c);
        }
    }
}




us char getKeySw(us char ls,us char No){
 	us char sw,last,cnt;
 	cnt=0;
 	last= ls; //KeyXCb`̏
	while(cnt<CHATA){
		__delay_us(500);
 
		switch(No) {
		case 0: sw = KDIR;break;
		case 1: sw = KUP;break;
		case 2: sw = KDOWN;break;
		case 3: sw = KENTER;break;
		}
 		if(last==sw){ // ȌԂƔr
			cnt++; //
 			}else{
			cnt=0; //`^O
 			}
 		last=sw; // ̏ԂȌԂƂ
 		}
	return sw;
 	}
 void selectKDIR() {
	unsigned char sw;
	if (KDIR == 1) {lastKDIR = 1; return;}
	if (KDIR == lastKDIR) {return;}
	sw = getKeySw(KDIR,0);
	lastKDIR = sw;
	if ((sw == 0) && (KDIR == 0)) {
       // GLED=1;
        __delay_ms(200) ;
		SD_CK = finnd_SD_card();
		if (SD_CK == 1){
			disp_dir_fname();
		}
	}
}
 void selectKUP() {
	unsigned char sw;
	if (KUP == 1) {lastKUP = 1; return;}
	if (KUP == lastKUP) {return;}
	sw = getKeySw(KUP,1);
	lastKUP = sw;
	if (sw == 0) {
        FX=15;FY=25+(15*FnameIndex);
        strcpy(str,readFname[FnameIndex]);mojicolor=7;
        mojiretsudisp_mk2(FX,FY,7,str,2);// FX,FY,Fontԍ,Xp
        FnameIndex--;if (FnameIndex <= 1){FnameIndex = 1;}
        FX = 15;FY=25+(15*FnameIndex);
        strcpy(str,readFname[FnameIndex]);mojicolor=2;
        mojiretsudisp_mk2(FX,FY,7,str,2);// FX,FY,Fontԍ,Xp
	}
}
void selectKDOWN() {
	unsigned char sw,lastid;
	if (KDOWN == 1) {lastKDOWN = 1; return;}
	if (KDOWN == lastKDOWN) {return;}
	sw = getKeySw(KDOWN,2);
	lastKDOWN = sw;
	if (sw == 0) {
        FX=15;FY=25+(15*FnameIndex);mojicolor=7;
        strcpy(str,readFname[FnameIndex]);
        mojiretsudisp_mk2(FX,FY,7,str,2);// FX,FY,Fontԍ,Xp
        FnameIndex++;if (FnameIndex >= maxFname){FnameIndex = maxFname;}
        FX=15;FY=25+(15*FnameIndex);
        strcpy(str,readFname[FnameIndex]);mojicolor=2;
        mojiretsudisp_mk2(FX,FY,7,str,2);// FX,FY,Fontԍ,Xp
	}
}
void selectKENTER() {
	unsigned char sw;
	if (KENTER == 1) {lastKENTER = 1; return;}
	if (KENTER == lastKENTER) {return;}
	sw = getKeySw(KENTER,3);
	lastKENTER = sw;
	if (sw == 0) {
        File_open(FnameIndex);
	}
}
void fname16tofname8(uint16_t *fname){
    unsigned char i ;
    for (i=0;i<32;i++){
    str[i]=(uint16_t)fname[i];
    }
}

 void FnameSort(unsigned char n) {
    int i, j;
    char temp[32];           //  Ɨp|C^ 
	
    for (i = 0; i < n - 1; i++) {
        for (j = i + 1; j < n; j++) {
            if ((strcmp(readFname[j], readFname[i])) > 0) {
                strcpy(temp, readFname[i]);                
                strcpy(readFname[i], readFname[j]);            
                strcpy(readFname[j], temp);               
            }
        }
      
    }
}

void find_fname_disp(us char yd, us char cm,us char cb) {
    unsigned char xd,xa,i,ya;
    unsigned char str[32];
    GLED=1;
    xd=15;
//    ya = 15*yd;
     FX=15;
     FY=25+(15*yd);
     if (yd == FnameIndex){mojicolor=2;}else{mojicolor=cm;}
      strcpy(str,readFname[yd]);
      
     mojiretsudisp_mk2(FX,FY,7,str,2);// FX,FY,Fontԍ,Xp
     
}

void disp_dir_fname(){
    unsigned char yd,ymax;
    lcd_CMD(0x36);
    lcd_DATA(0b01100100);
    ymax=maxFname;
    FnameIndex=0;
    if (maxFname > 9) {ymax=9;}
    for (yd=0;yd <= ymax;yd++) {
         find_fname_disp(yd,7,8); 
        }
     if (maxFname > 9) {
        backcolor=0;mojicolor=7; 
         FX=20;FY=220;
         mojiretsudisp_mk2(FX,FY,7,"OVER",2);
     }
}
 
 

void Bmpdisplay(us int grx,us int gry,us int col,us int row,uint16_t *file) {
  	unsigned char c1,c2,cr,cg,cb,cd;
	us int G_col=col-1;
	us int G_row=row-1;
	unsigned int x,y,k,cc0,cc1,cc2;
    unsigned long int c0;
	k=0;
    lcd_CMD(0x36);
    lcd_DATA(0b00100100);
 	set_col_range(grx,grx+G_col);
 	set_row_range(gry,gry+G_row);
 	lcd_CMD(0x2C);//Ff[^
 	for (y=0;y<=G_row;y++) {
            for (x=0;x<=G_col;x++) {
 
                cb=FILEIO_GetChar(file);
                cg=FILEIO_GetChar(file);
                cr=FILEIO_GetChar(file);
                
                cr=255-cr;
                cg=255-cg;
                cb=255-cb;
                lcd_DATA(cr);
                lcd_DATA(cg);
                lcd_DATA(cb);
            }
 	}
}


void mediacheck() {

	if (SD_CD != lastSD_CD) {
     backcolor=8;
    mojicolor=7;
    write_line(0,0,100,150,8);//Xs,Ys,Xe,Ye,Color 
    FX=15;FY=10;
    if (SD_CD == 1) {
        mojiretsudisp_mk2(FX,FY,7,"NO MEDIA   ",2);// FX,FY,Fontԍ,Xp
        No_media=1;
        } else {
        mojiretsudisp_mk2(FX,FY,7,"MEDIA READY",2);// FX,FY,Fontԍ,Xp
        No_media=0;
        }
		lastSD_CD = SD_CD;
	}
}



void set_dir_fname(char *dir_fname,unsigned int yd){
    maxFname=yd;
    strcpy(readFname[yd],dir_fname);
}

void File_open(int index) {
     if (No_media == 1) {return;}
        strcpy(str,readFname[index]);mojicolor=4;
      
     mojiretsudisp_mk2(180,25,7,str,2);// FX,FY,Fontԍ,Xp
       SD_CK=open_SD_card(readFname[index]);
}	


void testdisp( char *coment,signed int val,us char degi){
    FX=xt;FY=yt+15*st;
    mojiretsudisp_mk2(FX,FY,7,coment,2);// FX,FY,Fontԍ,Xp
    integerdisp(FX+20, FY,7,degi, val, 2);
    st++;
}
void 	analysGIFdata(){
    uint8_t st[6];
    uint8_t i,BitCount,Comp;
    
    for(i=0;i<2;i++){
        st[i]=GIFdata[i];
    } 
    st[2]=0;
//    testdisp(st,0,1);
    Hgif = GIFdata[0x12] | GIFdata[0x13]<<8;
//    testdisp("Hgif",Hgif,3);
    Vgif = GIFdata[0x16] |GIFdata[0x17]<<8;
//    testdisp("Vgif",Vgif,3);
    offset = GIFdata[0x0A] | GIFdata[0x0B]<<8;
//    testdisp("Ofset",offset,3);
    BitCount = GIFdata[0x1C] | GIFdata[0x1D]<<8;
//    testdisp("BitCount",BitCount,2);
    Comp = GIFdata[0x1e] | GIFdata[0x1F];
//    testdisp("Comp",Comp,2);
}
	


 int main()  {
 //unsigned int i,j;
 OSCCON = 0b0001000110100001; //Fosc FRCPLL 32MHz

  CLKDIV = 0x0000;
 AD1PCFGL = 0b1111111111111111;//AN
 RPOR9bits.RP19R = 11;//RP19SCK2蓖
 RPOR13bits.RP26R = 10;//RP26SDO2蓖

 SPI2BUF = 0x0;//SP2obt@[NA[
 
 SPI2CON1 = 0b0000000001111011;//Active_Low SDOgpB8bitA}X^[[h SP1/2 PP1/1
 SPI2CON2 = 0b000000000000000;//t[gp

 SPI2STATbits.SPIEN = 1;//SPI2L


 
 PORTB  = 0b0000000000000000;  //|[gB@Lo
 TRISB  = 0b1111000000000000; //RB12-15 input ̑Sďo͐ݒ
 PORTE   =0b0000000000000111; //|[gC@o͐ݒ
 TRISE  = 0b0000000000000000;//|[gESďo	
 TRISF  = 0b0000000000000100; //RF2 U1RXɐݒ
 TRISC  = 0b0000000000000000;  //|[gC@o
 TRISD  = 0b0000000000000011;  //|[gD@o
 TRISG  = 0b0000000000000000;  //|[gG@6,7,8o

 xt=180;yt=50;st=0;
CHATA = 60;
makecolorList();
init_LCD();//LCDݒ

//***********************************ʃNA[i1ԐF()őSʓhԂj
lcd_CMD(0x002C);//Ff[^

    lcd_CMD(0x29);//Display ON

	write_line(0,0,319,239,8);//Xs,Ys,Xe,Ye,Color 	
    mojicolor=7;backcolor = 8;

    mojicolor=4;

    lastSD_CD = 2;

    fname16tofname8(searchname);
    year=2025;

    while(1){

		mediacheck();
    	selectKDIR();
        selectKUP();
        selectKDOWN();
        selectKENTER();

    };
	

}
