//20241207
/********************************************************************
 Software License Agreement:

 The software supplied herewith by Microchip Technology Incorporated
 (the "Company") for its PIC(R) Microcontroller is intended and
 supplied to you, the Company's customer, for use solely and
 exclusively on Microchip PIC Microcontroller products. The
 software is owned by the Company and/or its supplier, and is
 protected under applicable copyright laws. All rights are reserved.
 Any use in violation of the foregoing restrictions may subject the
 user to criminal sanctions under applicable laws, as well as to
 civil liability for the breach of the terms and conditions of this
 license.

 THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION. NO WARRANTIES,
 WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
 TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT,
 IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
 CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *******************************************************************/

#include "system_config.h"
#include "system.h"
#include <xc.h>
#include <stdbool.h>
#include "sd_spi.h"

/** CONFIGURATION Bits **********************************************/
#pragma config JTAGEN = OFF
#pragma config GCP = OFF
#pragma config GWRP = OFF
#pragma config ICS = PGx1 //C

#pragma config PLL_96MHZ = ON
#pragma config IESO = OFF
#pragma config FCKSM = CSDCMD
#pragma config OSCIOFNC = ON
#pragma config POSCMOD = HS
#pragma config FNOSC = FRCPLL //OSC32MHzCRUɕύX
#pragma config PLLDIV = DIV2
#pragma config IOL1WAY = ON
#pragma config FWDTEN = OFF //WTD timer OFF

#define GLED LATBbits.LATB8 

void SYSTEM_Initialize (void)
{
    AD1PCFGL = 0xFFFF;
    TRISBbits.TRISB8 = 0;
}


void USER_SdSpiConfigurePins (void)
{
    //Initialize the SPI
    RPINR20bits.SDI1R = 25;//C
    RPOR10bits.RP20R = 7;//C
    RPOR11bits.RP22R = 8;   //C 

    //enable a pull-up for the card detect, just in case the SD-Card isn't attached
    //  then lets have a pull-up to make sure we don't think it is there.
    //CNPU5bits.CN68PUE = 1;//vAbv̓n[hōsĂ܂̂ŁA̍s͕sv

    // Deassert the chip select pin
    LATDbits.LATD2 = 1;//CS[qPɐݒ
    // Configure CS pin as an output
    TRISDbits.TRISD2 = 0;//CS[qo͂ɐݒ
    // Configure CD pin as an input
    TRISDbits.TRISD1 = 1;//CD[q͂ɐݒ
    // Configure WP pin as an input
    //TRISFbits.TRISF1 = 1;//̍s̓RgAEg
}

inline void USER_SdSpiSetCs(uint8_t a)
{
    LATDbits.LATD2 = a;//CS[qC
}

inline bool USER_SdSpiGetCd(void)
{
    return (!PORTDbits.RD1) ? true : false;//CD[qC
}

inline bool USER_SdSpiGetWp(void)
{
    //return (PORTFbits.RF1) ? true : false;//RgAEgĂOԂ

    return 0;
}

// The sdCardMediaParameters structure defines user-implemented functions needed by the SD-SPI fileio driver.
// The driver will call these when necessary.  For the SD-SPI driver, the user must provide
// parameters/functions to define which SPI module to use, Set/Clear the chip select pin,
// get the status of the card detect and write protect pins, and configure the CS, CD, and WP
// pins as inputs/outputs (as appropriate).
// For this demo, these functions are implemented in system.c, since the functionality will change
// depending on which demo board/microcontroller you're using.
// This structure must be maintained as long as the user wishes to access the specified drive.
FILEIO_SD_DRIVE_CONFIG sdCardMediaParameters =
{
    1,                                  // Use SPI module 2
    USER_SdSpiSetCs,                    // User-specified function to set/clear the Chip Select pin.
    USER_SdSpiGetCd,                    // User-specified function to get the status of the Card Detect pin.
    USER_SdSpiGetWp,                    // User-specified function to get the status of the Write Protect pin.
    USER_SdSpiConfigurePins             // User-specified function to configure the pins' TRIS bits.
};